diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
index eb78c91ca..bed83081e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobSkeleton.java
@@ -9,6 +9,7 @@ import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.weather.Weathers;
 import org.jetbrains.annotations.NotNull;
 
@@ -60,8 +61,9 @@ public class MobSkeleton extends MobMonster
         if(world.isDaytime())
         {
             float f = getBrightness(1.0F);
+            Weather weather;
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                && !world.getCurrentWeather().isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && (weather = world.getCurrentWeather()) != null &&  !weather.isDamp && (weather != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
index 6d34b806e..92a769a7c 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobZombie.java
@@ -26,10 +26,10 @@ public class MobZombie extends MobMonster
     {
         if(world.isDaytime())
         {
-            Weather currentWeather = world.getCurrentWeather();
             float f = getBrightness(1.0F);
+            Weather weather = world.getCurrentWeather();
             if(f > 0.5F && world.canBlockSeeTheSky(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z)) && random.nextFloat() * 30F < (f - 0.4F) * 2.0F
-                && !world.getCurrentWeather().isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
+                && weather != null && !weather.isDamp && (world.getCurrentWeather() != Weathers.OVERWORLD_FOG || world.weatherManager.getWeatherPower() < 0.75F))
             {
                 remainingFireTicks = 300;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java b/game/core/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
index 61a436ba7..786e1d73c 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/IVehicleEntry.java
@@ -1,10 +1,12 @@
 package net.minecraft.core.net.entity;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
 
 public interface IVehicleEntry<T> extends IPacketEntry<T> {
-    Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner);
+    Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag);
     PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, T trackedObject);
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
index ce5099a08..fae34dacf 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryArrow.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.projectile.ProjectileArrow;
@@ -12,6 +13,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryArrow implements IVehicleEntry<ProjectileArrow>, ITrackedEntry<ProjectileArrow> {
     @Override
@@ -40,7 +42,7 @@ public class NetEntryArrow implements IVehicleEntry<ProjectileArrow>, ITrackedEn
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         if (metadata == 2) {
             return new ProjectileArrowGolden(world, x, y, z);
         } else if (metadata == 1) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
index e7177fae9..5460a9ada 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBoat.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryBoat implements IVehicleEntry<EntityBoat>, ITrackedEntry<EntityBoat> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryBoat implements IVehicleEntry<EntityBoat>, ITrackedEntry<En
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new EntityBoat(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
index 266e98d12..14fa5cf4e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryBobber.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.entity.player.Player;
@@ -10,6 +11,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryBobber implements IVehicleEntry<EntityFishingBobber>, ITrackedEntry<EntityFishingBobber> {
     @Override
@@ -38,7 +40,7 @@ public class NetEntryBobber implements IVehicleEntry<EntityFishingBobber>, ITrac
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         EntityFishingBobber bobber = new EntityFishingBobber(world, x, y, z);
         if (owner != null) {
             bobber.owner = (Player) owner;
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
index 1b8ad3ad9..d205b6ce6 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryCannonball.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.projectile.ProjectileCannonball;
@@ -10,6 +11,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryCannonball implements IVehicleEntry<ProjectileCannonball>, ITrackedEntry<ProjectileCannonball> {
     @Override
@@ -38,7 +40,7 @@ public class NetEntryCannonball implements IVehicleEntry<ProjectileCannonball>,
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new ProjectileCannonball(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
index af9aef5cf..15eb1e43f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryEgg.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileEgg;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryEgg implements IVehicleEntry<ProjectileEgg>, ITrackedEntry<ProjectileEgg> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryEgg implements IVehicleEntry<ProjectileEgg>, ITrackedEntry<
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new ProjectileEgg(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
index a2cf723ce..5c4893e04 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFallingBlock.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityFallingBlock;
@@ -11,6 +12,7 @@ import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryFallingBlock implements IVehicleEntry<EntityFallingBlock>, ITrackedEntry<EntityFallingBlock> {
     @Override
@@ -39,12 +41,18 @@ public class NetEntryFallingBlock implements IVehicleEntry<EntityFallingBlock>,
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
-        return new EntityFallingBlock(world, x, y, z, MathHelper.clamp(metadata, 0, Blocks.blocksList.length), 0, null);
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
+        EntityFallingBlock fallingBlock = new EntityFallingBlock(world, x, y, z, MathHelper.clamp(metadata, 0, Blocks.blocksList.length), 0, null);
+        if (tag != null) {
+            fallingBlock.readAdditionalSaveData(tag);
+        }
+        return fallingBlock;
     }
 
     @Override
     public PacketAddEntity getSpawnPacket(EntityTrackerEntry tracker, EntityFallingBlock trackedObject) {
-        return new PacketAddEntity(trackedObject, trackedObject.carriedBlock.blockId);
+        CompoundTag tag = new CompoundTag();
+        trackedObject.addAdditionalSaveData(tag);
+        return new PacketAddEntity(trackedObject, -1, -1, null, null, null, tag);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
index acae630e1..e5742d591 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryFireball.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileFireball;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryFireball implements IVehicleEntry<ProjectileFireball>, ITrackedEntry<ProjectileFireball> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryFireball implements IVehicleEntry<ProjectileFireball>, ITra
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new ProjectileFireball(world, x, y, z, xd, yd, zd);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
index 792989d65..0493cf1ad 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryMinecart.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryMinecart implements IVehicleEntry<MinecartEntity>, ITrackedEntry<MinecartEntity> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryMinecart implements IVehicleEntry<MinecartEntity>, ITracked
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new MinecartEntity(world, x, y, z, metadata);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPebble.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPebble.java
index b80ce2cd5..8604301b5 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPebble.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectilePebble;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryPebble implements IVehicleEntry<ProjectilePebble>, ITrackedEntry<ProjectilePebble> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryPebble implements IVehicleEntry<ProjectilePebble>, ITracked
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new ProjectilePebble(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPrimedTNT.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPrimedTNT.java
index 722cca273..05da53498 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPrimedTNT.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntryPrimedTNT.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityPrimedTNT;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntryPrimedTNT implements IVehicleEntry<EntityPrimedTNT>, ITrackedEntry<EntityPrimedTNT> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntryPrimedTNT implements IVehicleEntry<EntityPrimedTNT>, ITrack
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new EntityPrimedTNT(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntrySnowball.java b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntrySnowball.java
index 414e3f1df..e5387b5de 100644
--- a/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntrySnowball.java
+++ b/game/core/src/main/java/net/minecraft/core/net/entity/entries/NetEntrySnowball.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.net.entity.entries;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.projectile.ProjectileSnowball;
 import net.minecraft.core.net.entity.EntityTracker;
@@ -9,6 +10,7 @@ import net.minecraft.core.net.entity.IVehicleEntry;
 import net.minecraft.core.net.packet.PacketAddEntity;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
 public class NetEntrySnowball implements IVehicleEntry<ProjectileSnowball>, ITrackedEntry<ProjectileSnowball> {
     @Override
@@ -37,7 +39,7 @@ public class NetEntrySnowball implements IVehicleEntry<ProjectileSnowball>, ITra
     }
 
     @Override
-    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner) {
+    public Entity getEntity(World world, double x, double y, double z, int metadata, boolean hasVelocity, double xd, double yd, double zd, Entity owner, @Nullable CompoundTag tag) {
         return new ProjectileSnowball(world, x, y, z);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index 4fdc21288..5fd4d72c0 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -194,7 +194,7 @@ public abstract class Packet
         return result;
     }
 
-    public static void writeCompressedCompoundTag(CompoundTag tag, DataOutputStream dos)
+    public static void writeCompressedCompoundTag(@NotNull CompoundTag tag, DataOutputStream dos)
             throws IOException
     {
         ByteArrayOutputStream baos = new ByteArrayOutputStream();
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddEntity.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddEntity.java
index c8b51221d..5f5b30928 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddEntity.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddEntity.java
@@ -1,14 +1,21 @@
 package net.minecraft.core.net.packet;
 
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.Nullable;
 
 import java.io.DataInputStream;
 import java.io.DataOutputStream;
 import java.io.IOException;
 
 public class PacketAddEntity extends Packet {
+    public static final int MASK_OWNER = 0b0000_0001;
+    public static final int MASK_META = 0b0000_0010;
+    public static final int MASK_VELOCITY = 0b0000_0100;
+    public static final int MASK_TAG = 0b000_1000;
+
     public int entityId;
     public int xPosition;
     public int yPosition;
@@ -22,14 +29,16 @@ public class PacketAddEntity extends Packet {
     public short type = -1;
     public int ownerId = -1;
     public int metaData = -1;
+    public @Nullable CompoundTag tag;
     public PacketAddEntity() {}
     public PacketAddEntity(Entity entity)
     {
-        this(entity, -1, -1, null, null, null);
+        this(entity, -1, -1, null, null, null, null);
     }
-    public PacketAddEntity(Entity entity, int metaData){ this(entity, metaData, -1, null, null, null); }
-    public PacketAddEntity(Entity entity, int metaData, int ownerId){ this(entity, metaData, ownerId, null, null, null); }
-    public PacketAddEntity(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity) {
+    public PacketAddEntity(Entity entity, int metaData){ this(entity, metaData, -1, null, null, null, null); }
+    public PacketAddEntity(Entity entity, int metaData, int ownerId){ this(entity, metaData, ownerId, null, null, null, null); }
+    public PacketAddEntity(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity) { this(entity, metaData, ownerId, xVelocity, yVelocity, zVelocity, null); }
+    public PacketAddEntity(Entity entity, int metaData, int ownerId, Double xVelocity, Double yVelocity, Double zVelocity, @Nullable CompoundTag tag) {
         this.entityId = entity.id;
         this.xPosition = MathHelper.floor(entity.x * 32D);
         this.yPosition = MathHelper.floor(entity.y * 32D);
@@ -46,6 +55,7 @@ public class PacketAddEntity extends Packet {
         } else {
             this.hasVelocity = false;
         }
+        this.tag = tag;
     }
     public PacketAddEntity setType(int type){
         this.type = (short) type;
@@ -76,6 +86,9 @@ public class PacketAddEntity extends Packet {
         if (hasMeta(optionals)){
             metaData = dis.readInt();
         }
+        if (hasTag(optionals)) {
+            tag = readCompressedCompoundTag(dis);
+        }
     }
 
     @Override
@@ -87,7 +100,7 @@ public class PacketAddEntity extends Packet {
         dos.writeInt(zPosition);
         dos.writeFloat(pitch);
         dos.writeFloat(yaw);
-        byte optionals = makeOptionalsByte(hasVelocity, ownerId >= 0, metaData >= 0);
+        byte optionals = makeOptionalsByte(hasVelocity, ownerId >= 0, metaData >= 0, tag != null);
         dos.writeByte(optionals);
 
         if(hasVelocity(optionals)) {
@@ -101,26 +114,35 @@ public class PacketAddEntity extends Packet {
         if(hasMeta(optionals)) {
             dos.writeInt(metaData);
         }
+        if (hasTag(optionals)) {
+            writeCompressedCompoundTag(tag, dos);
+        }
     }
     public boolean hasOwner(byte val){
-        return (val &   0b1) != 0;
+        return (val & MASK_OWNER) != 0;
     }
     public boolean hasMeta(byte val){
-        return (val &  0b10) != 0;
+        return (val & MASK_META) != 0;
     }
     public boolean hasVelocity(byte val){
-        return (val & 0b100) != 0;
+        return (val & MASK_VELOCITY) != 0;
     }
-    public byte makeOptionalsByte(boolean hasVelocity, boolean hasOwner, boolean hasMeta){
+    public boolean hasTag(byte val){
+        return (val & MASK_TAG) != 0;
+    }
+    public byte makeOptionalsByte(boolean hasVelocity, boolean hasOwner, boolean hasMeta, boolean hasCompound){
         byte val = 0;
         if (hasOwner){
-            val |=   0b1;
+            val |= MASK_OWNER;
         }
         if (hasMeta){
-            val |=  0b10;
+            val |= MASK_META;
         }
         if (hasVelocity){
-            val |= 0b100;
+            val |= MASK_VELOCITY;
+        }
+        if (hasCompound){
+            val |= MASK_TAG;
         }
         return val;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 9029ed847..2aefe2c52 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -419,7 +419,7 @@ public class World implements WorldSource {
         return chunkProvider.saveChunks(false, null);
     }
 
-    public Weather getCurrentWeather()
+    public @Nullable Weather getCurrentWeather()
     {
         return (weatherManager == null) ? null : weatherManager.getCurrentWeather();
     }
diff --git a/util/stellar/src/main/java/org/useless/stellar/StarUtil.java b/util/stellar/src/main/java/org/useless/stellar/StarUtil.java
index 0bc779eea..a0ec3d058 100644
--- a/util/stellar/src/main/java/org/useless/stellar/StarUtil.java
+++ b/util/stellar/src/main/java/org/useless/stellar/StarUtil.java
@@ -102,7 +102,7 @@ public class StarUtil {
 
             glBegin(GL_QUADS);
 
-            final int startOffset = 1000;
+            final int startOffset = 1500;
             final int tempRange = 17500;
             final int bandWidth = 4;
             final int iterations = tempRange/bandWidth;
